VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsImage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit


Private Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Long
  bmBitsPixel As Long
  bmBits As Long
End Type

Private Type BITMAPINFOHEADER '40 bytes
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type

Private Type RGBQUAD
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
End Type

Private Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As RGBQUAD
End Type

'################################################################
'## Soubor =  cesta k souboru s platnym obrazkem BMP
'## TexturesBMP() = dynamicke pole Long, provede ReDim Preserve + 1 a na predposledni index vlozi texturu
'## pokud se texturu nepodari vytvorit vraci False
'#################################################################
Public Function LoadTexturesBMP(ByVal soubor As String, ByRef TexturesBMP() As Long) As Boolean
Dim FileInfo As BITMAPFILEHEADER, Header As BITMAPINFOHEADER
Dim Nr As Integer, ImageSize As Long, BytesPerPixel As Integer
Dim FileRGB() As RGBQUAD, Data() As Byte, tmpTex As GLint

On Error GoTo Chyba
  
  Nr = FreeFile
  Open soubor For Binary As Nr
    Get #Nr, , FileInfo
    Get #Nr, , Header
    
    If (Header.biBitCount < 24) Then
      ReDim FileRGB(Header.biClrUsed)
      Get #Nr, , FileRGB
    End If
    
    BytesPerPixel = Header.biBitCount / 8
    ImageSize = Header.biWidth * Header.biHeight * BytesPerPixel
  
    ReDim Data(ImageSize)
    
    Get #Nr, , Data
  Close #Nr
    
  Nr = UBound(TexturesBMP)
  ReDim Preserve TexturesBMP(Nr + 1)
  
  glGenTextures 1, TexturesBMP(Nr)
  glBindTexture glTexture2D, TexturesBMP(Nr)
  glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
  glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
  
  glTexImage2D glTexture2D, 0, BytesPerPixel, Header.biWidth, Header.biHeight, 0, GL_BGR_EXT, GL_UNSIGNED_BYTE, Data(0)
    
  Erase Data
  LoadTexturesBMP = True
Exit Function
  
Chyba:
  Select Case Err.Number
    Case Else
      MsgBox Err.Description
      LoadTexturesBMP = False
  End Select
End Function

'################################################################
'## Soubor =  cesta k souboru s platnym obrazkem TGA
'## Textures_ID_TGA() = dynamicke pole Long, provede ReDim Preserve + 1 a na predposledni index vlozi texturu
'## pokud se texturu nepodari vytvorit vraci False
'#################################################################
Public Function LoadTexturesTGA(ByVal mFile As String, ByRef Textures_ID_TGA() As Long) As Boolean
Dim Test_Header, FileData() As Byte, MemData() As Byte, chHeader As Integer
Dim Nr As Long, M As Long, j As Long, act As Long, mFileLen As Long
Dim Header(17) As Byte, BytesPerPixel As Integer, ImageSize As Long
Dim Height As Long, Width As Long, Bpp As Byte
Dim AF As Long 'aktualni pozice v dekom. poli
Dim AM As Long 'aktualni pozoce v docasnem poli
Dim Compress As Boolean
On Error GoTo Chyba
  
Nr = FreeFile
Open mFile For Binary As #Nr
  Get #Nr, , Header
Close #Nr

' porovname prvnich 12 bytu a overi zda se jedna o platny soubor Targa a zda je komprimovan
Select Case Header(2)
  Case 2 'RAW Header
    Test_Header = Array(0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0)
    For j = 0 To 11
      If Header(j) <> Test_Header(j) Then GoTo Chyba
    Next
    Compress = False
  Case 10 'RLE Header
    Test_Header = Array(0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0)
    For j = 0 To 11
      If Header(j) <> Test_Header(j) Then GoTo Chyba
    Next
    Compress = True
  Case Else 'unknown Header
    GoTo Chyba
End Select
  
  
Width = Header(13) * 256 + Header(12)
Height = Header(15) * 256 + Header(14)
Bpp = Header(16)
BytesPerPixel = Bpp / 8
ImageSize = CLng(Width * Height * BytesPerPixel)
  
If Height <= 0 And Width <= 0 Then GoTo Chyba
If Bpp <> 24 And Bpp <> 32 Then GoTo Chyba
mFileLen = FileLen(mFile) - 18
ReDim FileData(mFileLen)
ReDim MemData(ImageSize)

Select Case Compress
  Case False 'RAW file
    Nr = FreeFile
    Open mFile For Binary As #Nr
      Get #Nr, 19, FileData
    Close #Nr
    
    If BytesPerPixel = 3 Then  'No alpha
      For j = 1 To ImageSize Step 3
        MemData(j - 1) = FileData(j + 1)
        MemData(j) = FileData(j)
        MemData(j + 1) = FileData(j - 1)
      Next
    Else
      For j = 1 To ImageSize Step 4  'With alpha
        MemData(j - 1) = FileData(j + 1)
        MemData(j) = FileData(j)
        MemData(j + 1) = FileData(j - 1)
        MemData(j + 2) = FileData(j + 2)
      Next
    End If
  Case True 'RLE file
    Nr = FreeFile
    Open mFile For Binary As #Nr
      Get #Nr, 19, FileData
    Close #Nr
 
    AM = 0: AF = 0
  
    If BytesPerPixel = 3 Then 'No alpha
      Do While AM < ImageSize
        chHeader = FileData(AF)
        AF = AF + 1
        If chHeader <= 127 Then 'RAW block
          For j = 0 To chHeader
            MemData(AM) = FileData(AF + 2)
            AM = AM + 1
            MemData(AM) = FileData(AF + 1)
            AM = AM + 1
            MemData(AM) = FileData(AF)
            AF = AF + 3: AM = AM + 1
          Next
        Else
          For j = 1 To chHeader - 127 'RLE block
            MemData(AM) = FileData(AF + 2)
            AM = AM + 1
            MemData(AM) = FileData(AF + 1)
            AM = AM + 1
            MemData(AM) = FileData(AF)
            AM = AM + 1
          Next
          AF = AF + 3
        End If
    Loop
  Else 'with alpha
    Do While AM < ImageSize
      chHeader = FileData(AF)
      AF = AF + 1
      If chHeader <= 127 Then 'RAW block
        For j = 0 To chHeader
          MemData(AM) = FileData(AF + 2)
          AM = AM + 1
          MemData(AM) = FileData(AF + 1)
          AM = AM + 1
          MemData(AM) = FileData(AF)
          AM = AM + 1
          MemData(AM) = FileData(AF + 3)
          AF = AF + 4: AM = AM + 1
        Next
      Else
        For j = 1 To chHeader - 127 'RLE block
          MemData(AM) = FileData(AF + 2)
          AM = AM + 1
          MemData(AM) = FileData(AF + 1)
          AM = AM + 1
          MemData(AM) = FileData(AF)
          AM = AM + 1
          MemData(AM) = FileData(AF + 3)
          AM = AM + 1
        Next
        AF = AF + 4
      End If
    Loop
  End If
End Select
'pouze docasne, v budoucnu mimo tridu
j = UBound(Textures_ID_TGA)
ReDim Preserve Textures_ID_TGA(j + 1)
  
glGenTextures 1, Textures_ID_TGA(j)
glBindTexture glTexture2D, Textures_ID_TGA(j)
glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
glTexImage2D glTexture2D, 0, BytesPerPixel, Width, Height, 0, IIf(BytesPerPixel = 3, GL_RGB, GL_RGBA), GL_UNSIGNED_BYTE, MemData(0)

LoadTexturesTGA = True
Exit Function

Chyba:
  LoadTexturesTGA = False
  Exit Function
End Function
